=== debian/control ===
Source: ros-galactic-ur-client-library
Section: misc
Priority: optional
Maintainer: Felix Exner <exner@fzi.de>
Build-Depends: debhelper (>= 9.0.0), cmake, ros-galactic-ros-workspace
Homepage: http://wiki.ros.org/ur_client_library
Standards-Version: 3.9.2

Package: ros-galactic-ur-client-library
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-ament-cmake, ros-galactic-ros-workspace
Description: Standalone C++ library for accessing Universal Robots interfaces.
 This has been forked off the ur_robot_driver.
